Subject: Re: [RFC] netlink: add socket destruction notification

From: Patrick McHardy <[email-masked]>
Date: Fri, 06 Nov 2009 16:21:29 +0100

Johannes Berg wrote:
> When we want to keep track of resources associated with applications, we
> need to know when an app is going away. Add a notification function to
> netlink that tells us that, and also hook it up to generic netlink so
> generic netlink can notify the families. Due to the way generic netlink
> works though, we need to notify all families and they have to sort out
> whatever resources some commands associated with the socket themselves.
> 

> @@ -166,6 +167,9 @@ static void netlink_sock_destruct(struct
>  		return;
>  	}
>  
> +	if (nlk->destruct)
> +		nlk->destruct(sk);
> +
>  	WARN_ON(atomic_read(&sk->sk_rmem_alloc));
>  	WARN_ON(atomic_read(&sk->sk_wmem_alloc));
>  	WARN_ON(nlk_sk(sk)->groups);

This seems pretty similar to the NETLINK_URELEASE notifier invoked
in netlink_release(). Wouldn't that one work as well?